from guizero import App, Text, PushButton, TextBox, Picture, Box, MenuBar, error, Window
import tkinter as tk
from tkinter import filedialog, messagebox
from core_program import FitterProgram, keys_to_index, index_to_keys
import json
import sys
from matplotlib.backends.backend_tkagg import (
    FigureCanvasTkAgg, NavigationToolbar2Tk)
import copy
import webbrowser


'''
GUI
'''

def yes_button_CFX():
    if not scan_freq_box.value.isdigit():
        error("input error", "You must type a number")
    try:
        program.process_data_CFX(scan_freq_box.value)
    except Exception as exc:
        error('Error', exc)
    window_CFX.hide()
    open_file_CFX()

def no_button_CFX():
    if not scan_freq_box.value.isdigit():
        error("input error", "You must type a number")
    try:
        program.process_data_CFX(scan_freq_box.value)
    except Exception as exc:
        error('Error', exc)
    window_CFX.hide()
    program.curve_analysis()
    program.double_fitting()
    canvas.draw()

def yes_button_AriaMx():
    if not scan_freq_box_Aria.value.isdigit():
        error("input error", "You must type a number")
    try:
        program.process_data_AriaMx(scan_freq_box_Aria.value)
    except Exception as exc:
        error('Error', exc)
    window_AriaMx.hide()
    open_file_AriaMx()

def no_button_AriaMx():
    if not scan_freq_box_Aria.value.isdigit():
        error("input error", "You must type a number")
    try:
        program.process_data_AriaMx(scan_freq_box_Aria.value)
    except Exception as exc:
        error('Error', exc)
    window_AriaMx.hide()
    program.curve_analysis()
    program.double_fitting()
    canvas.draw()

def button_clear():
    for j in range(1, 9):
        for i in range(1, 13):
            button[j][i].text = ''
            textboxes[j][i].value = ''
            if button[j][i].bg == '#FFA500':
                button[j][i].bg = 'white'
                textboxes[j][i].bg = 'white'
                button[j][i].tk.config(highlightbackground = 'white', highlightthickness = 0)
            elif button[j][i].bg == '#C0C0C0':
                button[j][i].bg = 'white'
                button[j][i].tk.config(highlightbackground = 'white', highlightthickness = 0)
    for i in range(1, 13):
        if button[0][i].bg == '#FFA500':
            button[0][i].bg = 'white'
            button[0][i].tk.config(highlightbackground = 'white', highlightthickness = 0)
    for j in range(1, 9):
        if button[j][0].bg == '#FFA500':
            button[j][0].bg = 'white'
            button[j][0].tk.config(highlightbackground = 'white', highlightthickness = 0)

def open_CFX_window():
    scan_freq_box.clear()
    window_CFX.show(wait = True)

def open_AriaMx_window():
    scan_freq_box_Aria.clear()
    window_AriaMx.show(wait = True)

def open_QS_window():
    scan_freq_box_QS.clear()
    global Cycle_list
    global Box_list
    
    index_list = []
    for index in range(1, len(Box_list)):
        index_list.append(index)

    for index in index_list:
        widget = Box_list[index]
        widget.destroy()
                       
    Box_list = [scan_box_QS]
    Cycle_list = [[scan_freq_box_QS]]
    window_QS.show(wait = True)
    
def open_file_CFX():
    filename = filedialog.askopenfilename()
    if filename != '':
        try:
            program.filereader_CFX(filename)
            open_CFX_window()
        except Exception as exc:
            error('Error', exc)
    elif len(program.raw) != 0:
        try:
            program.curve_analysis()
            program.double_fitting()
        except Exception as exc:
            error('Error',exc)
        canvas.draw()

def open_file_AriaMx():
    filename = filedialog.askopenfilename()
    if filename != '':
        try:
            program.filereader_AriaMx(filename)
            open_AriaMx_window()
        except Exception as exc:
            error('Error', exc)
    elif len(program.raw) != 0:
        try:
            program.curve_analysis()
            program.double_fitting()
        except Exception as exc:
            error('Error',exc)
        canvas.draw()   
    
def open_file_QuantStudio():
    program.clear_everything()
    canvas.draw()
    button_clear()
    filename = filedialog.askopenfilename()
    if filename != '':
        try:
            program.filereader_QuantStudio(filename)
            open_QS_window()
        except Exception as exc:
            error('Error',exc) 
        
def save_file():
    try:
        with open(filedialog.asksaveasfilename(defaultextension=".dntp", filetypes=(("dNTP", "*.dntp"), ("All Files", "*.*"))), "w") as file:

            data = {
                    "raw_data": program.raw,
                    "lag_splitted": program.lag_splitted,
                    "double_fitted": program.double_fitted,
                    "single_fitted": program.single_fitted, #????? kell ez ide??
                    "result": program.result,
                    "calib_all": program.calib_all,
                    "calib_eff": program.calib_eff,
                    "outer": program.outer,
                    "zero": program.zero,
                    "x_minutes": program.x_minutes,
                    "average_k2": program.average_k2,
                    "calAmplitude": program.calAmplitude,
                    "x_pmol": program.x_pmol,
                    "slope": program.slope,
                    "intercept": program.intercept,
                    "R2": program.R2,
                    "calib_ready": program.is_calibration_ready,
                    "split_j": program.split_j,
                    "runtwarn": program.runtwarn,
                    "optwarn": program.optwarn,
                    "min_cal": program.min_cal,
                    "max_cal": program.max_cal,
                    "outer_results": program.outer_results,
                    "empty_wells": program.empty_wells,
                    "Akaike_single": program.Akaike_single,
                    "equal_k1_k2": program.equal_k1_k2,
                    "wrong_k1": program.wrong_k1,
                    "wrong_k2": program.wrong_k2,
                    "negative_A1": program.negative_A1,
                    "close_to_zero": program.close_to_zero,
                    "A1_high_error": program.A1_high_error,
                    "param_high_error": program.param_high_error
                }

            json.dump(data, file)
    except FileNotFoundError:
        pass
        
def open_dntp():
    try: 
        with open(filedialog.askopenfilename(filetypes=[("dNTP files", "*.dntp")]), "r") as ofile:
            data = json.load(ofile)

            program.raw = data["raw_data"]
            program.lag_splitted = data["lag_splitted"]
            program.double_fitted = data["double_fitted"]
            program.single_fitted = data["single_fitted"] #nem tom kell-e ide
            program.result = data["result"]
            program.calib_all = data["calib_all"]
            program.calib_eff = data["calib_eff"]
            program.outer = data["outer"]
            program.zero = data["zero"]
            program.x_minutes = data["x_minutes"]
            program.average_k2 = data["average_k2"]
            program.calAmplitude = data["calAmplitude"]
            program.x_pmol = data["x_pmol"]
            program.slope = data["slope"]
            program.intercept = data["intercept"]
            program.R2 = data["R2"]
            program.is_calibration_ready = data["calib_ready"]
            program.split_j = data["split_j"]
            program.runtwarn = data["runtwarn"]
            program.optwarn = data["optwarn"]
            program.min_cal = data["min_cal"]
            program.max_cal = data["max_cal"]
            program.outer_results = data["outer_results"]
            program.empty_wells = data["empty_wells"]
            program.Akaike_single = data["Akaike_single"]
            program.equal_k1_k2 = data["equal_k1_k2"]
            program.wrong_k1 = data["wrong_k1"]
            program.wrong_k2 = data["wrong_k2"]
            program.negative_A1 = data["negative_A1"]
            program.close_to_zero = data["close_to_zero"]
            program.A1_high_error = data["A1_high_error"]
            program.param_high_error = data["param_high_error"]
            
            
            for keys in program.double_fitted:

                j, N = keys_to_index(keys)

                if keys in program.calib_eff:
                    button[j][int(N)].bg = '#FFA500'
                    button[j][int(N)].tk.config(highlightbackground = '#FFA500', highlightthickness = 5)
                elif keys in program.outer or keys in program.zero:
                    button[j][int(N)].bg = '#C0C0C0'
                    button[j][int(N)].tk.config(highlightbackground = '#C0C0C0', highlightthickness = 5)
                if program.is_calibration_ready == True:
                    try:
                        button[j][int(N)].text = str('{:.1f}'.format(program.result[keys]))
                    except ValueError:
                        button[j][int(N)].text = str('{}'.format(program.result[keys]))
                    try:
                        program.calib_calc()
                    except Exception as exc:
                        error('Error', exc)            
            canvas.draw()
    except FileNotFoundError:
        pass

def recalc():
    try:
        program.calib_calc()
    except Exception as exc:
        error('Error', exc)
    canvas.draw()
    
    for j in range(1, 9):
        for i in range(1, 13):
            key = index_to_keys(i, j)
            if key in program.calib_all:
##                button[j][i].text = str(program.calib_all[key])
                if key in program.zero or key in program.outer:
                    button[j][i].bg = '#C0C0C0'
                    button[j][i].tk.config(highlightbackground = '#C0C0C0', highlightthickness = 5)
            elif button[j][i].bg == 'white':
                try:
                    button[j][i].text = str('{:.1f}'.format(program.result[key]))
                except KeyError:
                    pass
                except ValueError:
                    button[j][i].text = str('{}'.format(program.result[key]))

def show_fit(event_data):
    i, j = event_data.widget.master.grid
    if i !=0 and j != 0:
        program.clear_subplot(1)
        key = index_to_keys(i, j)
        program.draw_curve(program.ax, key)
        canvas.draw()
        if button[j][i].bg == '#FFA500' and button[j][i].text != '' and program.is_calibration_ready == True:
            key = index_to_keys(i, j)
            program.calib_magnifier(key)
            canvas.draw()
    elif i == 0 or j== 0:
        restore_fit() 

def restore_calib(event_data):
    program.draw_calib(program.ax2)
    canvas.draw()
        
def restore_fit():
    program.clear_subplot(1)
    for j in range(1, 9):
        for i in range(1, 13):
            key = index_to_keys(i, j)
            program.draw_curve(program.ax, key)
    canvas.draw()
            
def save_cal():
    try:
        with open(filedialog.asksaveasfilename(defaultextension=".calib", filetypes=(("Calib", "*.calib"), ("All Files", "*.*"))), "w") as file:
            json.dump(program.calib_all, file)
    except FileNotFoundError:
        pass

def import_cal():
    try:
        with open(filedialog.askopenfilename(filetypes=[("Calib files", "*.calib")]), "r") as ofile:
            program.calib_all = json.load(ofile)
            for keys in program.calib_all:
                
                j, N = keys_to_index(keys)
                button[j][int(N)].text = str(program.calib_all[keys])
                button[j][int(N)].bg = '#FFA500'
                button[j][int(N)].tk.config(highlightbackground = '#FFA500', highlightthickness = 5)
                textboxes[j][int(N)].value = str(program.calib_all[keys])
    except FileNotFoundError:
        pass

def export():
    try:
        program.export_to_Excel(filedialog.asksaveasfilename(defaultextension=".xlsx", filetypes=(("Excel file", "*.xlsx"),("All Files", "*.*") )))
    except PermissionError:
        error('Permission denied', 'The file could not be saved because an other program is using it')
    except FileNotFoundError:
        pass

def reset():
    program.clear_everything()
    canvas.draw()
    button_clear()
                       
def button_click_handler(event_data):
    i, j = event_data.widget.master.grid
    if i == 0 and j == 0:
        last_y = None
        last_x = None
        for y in range(1, 9):
            for x in range(1, 13):
                if button[y][x].bg == '#FFA500':
                    textboxes[y][x].bg = '#FFA500'
                    button[y][x].visible = not button[y][x].visible
                    textboxes[y][x].visible = not textboxes[y][x].visible
                    last_y = y
                    last_x = x
        if program.is_calibration_ready == True:
            if textboxes[last_y][last_x].visible == False:
                recalc()
    elif j == 0:
        
        if button[j][i].bg == 'white':
            button[j][i].bg = '#FFA500'
            button[j][i].tk.config(highlightbackground = '#FFA500', highlightthickness = 5)
            for x in range(1, 9):
                button[x][i].bg = '#FFA500'
                button[x][i].tk.config(highlightbackground = '#FFA500', highlightthickness = 5)
                if program.is_calibration_ready == True:
                    button[x][i].text = ''
                
        elif button[j][i].bg == '#FFA500':
            button[j][i].bg = 'white'
            button[j][i].tk.config(highlightbackground = 'white', highlightthickness = 0)
            for x in range(1, 9):
                button[x][i].bg = 'white'
                button[x][i].tk.config(highlightbackground = 'white', highlightthickness = 0)
                textboxes[x][i].bg = 'white'
                key = index_to_keys(i, x)
                program.calib_all.pop(key, None)
                if key in program.calib_eff:
                    program.calib_eff.pop(key, None)
                elif key in program.zero:
                    program.zero.pop(key, None)
                elif key in program.outer:
                    program.outer.pop(key, None)
                button[x][i].text = ''
                textboxes[x][i].value = ''
           
    elif i == 0:
        
        if button[j][i].bg == 'white':
            button[j][i].bg = '#FFA500'
            button[j][i].tk.config(highlightbackground = '#FFA500', highlightthickness = 5)
            for y in range(1, 13):
                button[j][y].bg = '#FFA500'
                button[j][y].tk.config(highlightbackground = '#FFA500', highlightthickness = 5)
                if program.is_calibration_ready == True:
                    button[j][y].text = ''
                
        elif button[j][i].bg == '#FFA500':
            button[j][i].bg = 'white'
            button[j][i].tk.config(highlightbackground = 'white', highlightthickness = 0)
            for y in range(1, 13):
                button[j][y].bg = 'white'
                button[j][y].tk.config(highlightbackground = 'white', highlightthickness = 0)
                textboxes[j][y].bg = 'white'
                key = index_to_keys(y, j)
                program.calib_all.pop(key, None)
                if key in program.calib_eff:
                    program.calib_eff.pop(key, None)
                elif key in program.zero:
                    program.zero.pop(key, None)
                elif key in program.outer:
                    program.outer.pop(key, None)
                button[j][y].text = ''
                textboxes[j][y].value = ''
    else:
        if button[j][i].bg == 'white':
            button[j][i].bg = '#FFA500'
            button[j][i].tk.config(highlightbackground = '#FFA500', highlightthickness = 5)
            if program.is_calibration_ready == True:
                key = index_to_keys(i, j)
                program.result[key] = None
                button[j][i].text = ''
                if key in program.calib_trash:
                    button[j][i].text = program.calib_trash[key]
                    program.calib_all[key] = program.calib_trash[key]
                recalc() 
                
        elif button[j][i].bg == '#FFA500':
            if program.is_calibration_ready == True:
                if button[j][i].text != '':
                    button[j][i].bg = '#C0C0C0'
                    button[j][i].tk.config(highlightbackground = '#C0C0C0', highlightthickness = 5)
                    textboxes[j][i].bg = 'white'
                    key = index_to_keys(i, j)
                    program.outer[key] = float(button[j][i].text)
                    recalc()
                else:
                    button[j][i].bg = 'white'
                    button[j][i].tk.config(highlightbackground = 'white', highlightthickness = 0)
                    key = index_to_keys(i, j)
                    if key in program.calib_all:
                        program.calib_all.pop(key, None)
                    recalc()
            elif program.is_calibration_ready == False:
                button[j][i].bg = 'white'
                button[j][i].tk.config(highlightbackground = 'white', highlightthickness = 0)
                button[j][i].text = ''
                textboxes[j][i].value = ''
                key = index_to_keys(i, j)
                program.calib_all.pop(key, None)
                
        elif button[j][i].bg == '#C0C0C0':
            button[j][i].bg = 'white'
            button[j][i].tk.config(highlightbackground = 'white', highlightthickness = 0)
            key = index_to_keys(i, j)
            program.calib_trash[key] = program.outer[key]
            program.outer.pop(key, None)
            program.calib_all.pop(key, None)
            if key in program.calib_eff:
                program.calib_eff.pop(key, None)
            elif key in program.zero:
                program.zero.pop(key, None)
            button[j][i].text = ''
            textboxes[j][i].value = ''
            if program.is_calibration_ready == True:
                recalc()
##            try:
##                program.calib_all[key] = float(button[j][i].text)
##            except ValueError:
##                pass
##            recalc()    
    
def outlier_remover(event_data):
    i, j = event_data.widget.master.grid
    print(i, j)
    if program.is_calibration_ready == True:
        if button[j][i].bg == '#FFA500':
            button[j][i].bg = '#C0C0C0'
            button[j][i].tk.config(highlightbackground = '#C0C0C0', highlightthickness = 5)
            key = index_to_keys(i, j)
            program.calib_eff.pop(key, None)
            program.outer[key] = float(button[j][i].text)
            recalc()
            
        elif button[j][i].bg == '#C0C0C0':
            button[j][i].bg = '#FFA500'
            button[j][i].tk.config(highlightbackground = '#FFA500', highlightthickness = 5)
            key = index_to_keys(i, j)
            try:
                program.calib_all[key] = float(button[j][i].text)
            except ValueError:
                pass
            program.outer.pop(key, None)
            recalc()
        
            
def text_change_handler(event_data):
    i, j = event_data.widget.master.grid
    button[j][i].text = textboxes[j][i].value
    key = index_to_keys(i, j)
    program.calib_all[key] = float(button[j][i].text)


deleted_rows_index = []

def delete_row_QS(event_data):
    i, j = event_data.widget.master.grid
    deleted_rows_sum = 0
    
    for element in deleted_rows_index:
        if int(element) < int(j):
            deleted_rows_sum += 1
    deleted_rows_index.append(j)

    Box_list[int(j)-3-deleted_rows_sum].destroy()
    Box_list.pop(int(j)-3-deleted_rows_sum)
    Cycle_list.pop(j-3-deleted_rows_sum)
    x, y = Box_list[-1].grid
    
def add_more_rows_QS():
    if program.split_j == 0:
        X_text = Text(scan_box_QS, text='x', grid=[2,0], align='top')
        cycle_nm_QS = TextBox(scan_box_QS, grid = [3,0], align= 'top')
        cycle_nm_text_QS = Text(scan_box_QS, text='cycle number', grid = [4, 0], align = 'top')

        Cycle_list[0].append(cycle_nm_QS)
        program.split_j += 1
        x, y = Box_list[-1].grid
        scan_box_QS_2  = Box(window_QS, grid=[x,y+1], align = 'top', layout='grid')
        scan_freq_box_QS_2 = TextBox(scan_box_QS_2, grid=[0,0], align ='top')
        scan_freq_sec_QS_2 = Text(scan_box_QS_2, text='sec', grid = [1, 0], align = 'top')
        X_text_2 = Text(scan_box_QS_2, text='x', grid=[2,0], align='top')
        cycle_nm_QS_2 = TextBox(scan_box_QS_2, grid = [3,0], align= 'top')
        cycle_nm_text_QS_2 = Text(scan_box_QS_2, text='cycle number', grid = [4, 0], align = 'top')
        Box_list.append(scan_box_QS_2)
            
        minus_button = PushButton(scan_box_QS_2, text='-', padx=0, pady=0, width=2, height=1, grid = [5, 0], align = 'top')
        minus_button.when_clicked = delete_row_QS
        
        Cycle_list.append([scan_freq_box_QS_2, cycle_nm_QS_2])

        
        submit_button.grid[1] = y + 4
        
    else:
        x, y = Box_list[-1].grid
        copy_deleted_for_looping = copy.deepcopy(deleted_rows_index)
        for element in copy_deleted_for_looping:
            if element >= y:
                deleted_rows_index.remove(element)
        scan_box_QS_3  = Box(window_QS, grid=[x,y+1], align = 'top', layout='grid')
        scan_freq_box_QS_3 = TextBox(scan_box_QS_3, grid=[0,0], align ='top')
        scan_freq_sec_QS_3 = Text(scan_box_QS_3, text='sec', grid = [1, 0], align = 'top')
        X_text_3 = Text(scan_box_QS_3, text='x', grid=[2,0], align='top')
        cycle_nm_QS_3 = TextBox(scan_box_QS_3, grid = [3,0], align= 'top')
        cycle_nm_text_QS_3 = Text(scan_box_QS_3, text='cycle number', grid = [4, 0], align = 'top')
        Box_list.append(scan_box_QS_3)
        minus_button = PushButton(scan_box_QS_3, text='-', padx=0, pady=0, width=2, height=1, grid = [5, 0], align = 'top')
        minus_button.when_clicked = delete_row_QS
        
        Cycle_list.append([scan_freq_box_QS_3, cycle_nm_QS_3])
        
        submit_button.grid[1] = y + 4
        

def submit_calc():
    try:
        program.process_data_QS(Cycle_list)
        program.curve_analysis()
        program.double_fitting()
        canvas.draw()
        window_QS.hide()
    except Exception as exc:
        error('Error', exc)

def agreement():
    gatc.hide()
    program_window.show()
    

def not_yet():
    print("This function is not available yet")

def callback(url):
    webbrowser.open_new(url)

program = FitterProgram()
        
gatc = App(title = "License terms", height=550, width=425, bg='white', layout = 'auto')
try:
    gatc.tk.iconbitmap(r'nucleoTIDY_mini_icon.icns')
except:
    pass



'''
License agreement window
'''

empty_space_license = Box(gatc, align='top', height=30, width=300)

Picture_box = Box(gatc, align='top', height= 200, width=300)
try:
    logo_picture = Picture(Picture_box, image="nucleoTIDY_v2.png")
    logo_picture.height = 180
    logo_picture.width = 296
except:
    pass
program_subtitle = Text(gatc, text='The free software of quantifying\n cellular dNTP levels', align = 'top')

empty_space_license_2 = Box(gatc, align='top', height=10, width=300)
version_number = Text(gatc, align = 'top', text='Version number: 1.8.3', size=10)
license_terms_title = Text(gatc, align = 'top', text='License terms and Conditions:', size=10)

license_terms_summary_v2 = Text(gatc, align = 'top', text='Copyright(c) 2019 Eva Viola Suranyi, RCNS HAS\nThis software is under the license AGPLv3.0\nFor more information, plese visit:', size=10)
nucleotidy_link = Text(gatc, align = 'top', text='http://nucleotidy.enzim.ttk.mta.hu/', size=10)

empty_space_license_3 = Box(gatc, align='top', height=10, width=300)
please_cite = Text(gatc, align = 'top', text='When publishing data generated with this software, please cite:', size=10)
article = Text(gatc, align = 'top', text='JE Szabó, EV Surányi, BS Mébold, T Trombitás, M Cserepes, J Tóth\n"A tool for the precise quantitation of deoxyribonucleoside triphosphates\nfrom biological samples" Nucleic Acids Research, Vol 48, Page e45.', size=10)

nucleotidy_link.tk.bind("<Button-1>", lambda e: callback('http://nucleotidy.enzim.ttk.mta.hu'))

empty_space_license_3 = Box(gatc, align='top', height=20, width=300)


license_agreement_button = PushButton(gatc, text='I Agree License terms and Conditions', padx=0, pady=0,  align = 'top', command=agreement)
license_agreement_button.bg='#7CFC00'
license_agreement_button.tk.config(highlightbackground = '#7CFC00', highlightthickness = 5)

'''
QuantStudio pop-up window
'''

window_QS = Window(gatc, title = "Opened successfully", height=300, width=400, layout = 'grid', bg='white', visible = False)
greetings_QS = Text(window_QS, text='Opened successfully!', grid=[0,0], align = 'top')

try:
    window_QS.tk.iconbitmap(r'nucleoTIDY_mini_icon.icns')
except:
    pass

empty_space_QS = Box(window_QS, grid=[0,1], align='top', height=30, width=400)

scan_freq_text_QS = Text(window_QS, text='Please give the cycle length for the opened file', grid =[0,2], align = 'top')
scan_box_QS = Box(window_QS, grid=[0,3], align = 'top', layout='grid')

scan_freq_box_QS = TextBox(scan_box_QS, grid = [0,0], align= 'top')
scan_freq_sec_QS = Text(scan_box_QS, text='sec', grid = [1, 0], align = 'top')

Box_list = [scan_box_QS]
Cycle_list = [[scan_freq_box_QS]]

plus_button = PushButton(scan_box_QS, text='+', padx=0, pady=0, width=2, height=1, grid = [5, 0], align = 'top', command=add_more_rows_QS)
submit_button = PushButton(window_QS, text='Submit', grid=[0,7], align = 'top', command= submit_calc)

'''
CFX pop-up window
'''


window_CFX = Window(gatc, title = "Opened successfully", height=300, width=400, layout = 'grid', bg='white', visible = False)
greetings = Text(window_CFX, text='Opened successfully!', grid=[0,0], align = 'top')

try:
    window_CFX.tk.iconbitmap(r'nucleoTIDY_mini_icon.icns')
except:
    pass

empty_space = Box(window_CFX, grid=[0,1], align='top', height=30, width=400)
scan_freq_text = Text(window_CFX, text='Please give the cycle length for the opened file', grid =[0,2], align = 'top')
scan_box = Box(window_CFX, grid=[0,3], align = 'top', layout='grid')
scan_freq_box = TextBox(scan_box, grid = [0,0], align= 'top')
scan_freq_sec = Text(scan_box, text='sec', grid = [1, 0], align = 'top')
empty_space2 = Box(window_CFX, grid=[0,4], align='top', height=30, width=400)


open_again_question = Text(window_CFX, text='Do you want to open more files?', grid = [0, 5], align = 'top')
open_hint = Text(window_CFX, text='Select Yes, if you have a measurement with different\ntime intervals of plate reading.', grid=[0,6], align='top', size=10)
empty_space3 = Box(window_CFX, grid=[0,7], align='top', height=20, width=400)
button_box = Box(window_CFX, grid=[0,8], align = 'top', layout='grid')


boxes = [[None for i in range(3)] for j in range(1)]

for i in range(3):
    for j in range(1):
        boxes[j][i] = Box(button_box, align='top', height = 50, width = 50, grid=[i, j])
    
YES_button_CFX = PushButton(boxes[0][0], text='Yes', grid=[0,0], align='top', command = yes_button_CFX)
NO_button_CFX = PushButton(boxes[0][2], text='No', grid=[2,0], align = 'top', command = no_button_CFX)

'''
AriaMx pop-up window
'''


window_AriaMx = Window(gatc, title = "Opened successfully", height=300, width=400, layout = 'grid', bg='white', visible = False)
greetings_Aria = Text(window_CFX, text='Opened successfully!', grid=[0,0], align = 'top')
try:
    window_AriaMx.tk.iconbitmap(r'nucleotidy_mini_icon.ico')
except:
    pass

empty_space_Aria = Box(window_AriaMx, grid=[0,1], align='top', height=30, width=400)
scan_freq_text_Aria = Text(window_AriaMx, text='Please give the cycle length for the opened file', grid =[0,2], align = 'top')
scan_box_Aria = Box(window_AriaMx, grid=[0,3], align = 'top', layout='grid')
scan_freq_box_Aria = TextBox(scan_box_Aria, grid = [0,0], align= 'top')
scan_freq_sec_Aria = Text(scan_box_Aria, text='sec', grid = [1, 0], align = 'top')
empty_space2_Aria = Box(window_AriaMx, grid=[0,4], align='top', height=30, width=400)


open_again_question_AriaMx = Text(window_AriaMx, text='Do you want to open more files?', grid = [0, 5], align = 'top')
open_hint_Aria = Text(window_AriaMx, text='Select Yes, if you have a measurement with different\ntime intervals of plate reading.', grid=[0,6], align='top', size=10)
empty_space3_Aria = Box(window_AriaMx, grid=[0,7], align='top', height=20, width=400)
button_box_Aria = Box(window_AriaMx, grid=[0,8], align = 'top', layout='grid')


boxes_Aria = [[None for i in range(3)] for j in range(1)]

for i in range(3):
    for j in range(1):
        boxes_Aria[j][i] = Box(button_box_Aria, align='top', height = 50, width = 50, grid=[i, j])
    
YES_button_AriaMx = PushButton(boxes_Aria[0][0], text='Yes', grid=[0,0], align='top', command = yes_button_AriaMx)
NO_button_AriaMx = PushButton(boxes_Aria[0][2], text='No', grid=[2,0], align = 'top', command = no_button_AriaMx)

'''
Main window alias Program window
'''

program_window = Window(gatc, title = "NucleoTIDY", width=1100, height=625, bg='white', layout = 'auto', visible = False)
try:
    program_window.tk.iconbitmap(r'nucleoTIDY_mini_icon.icns')
except:
    pass
menubar = MenuBar(program_window,
                  toplevel=["File", "Easy calibration", "Calculate", "Help"],
                  options=[
                      [ ["Open exported CFX", open_file_CFX], ["Open exported QuantStudio/StepOne", open_file_QuantStudio], ["Open exported AriaMx", open_file_AriaMx], ["Reset everything", reset], ["Save dntp result", save_file], ["Open dntp file", open_dntp], ["Export Results", export] ],
                      [ ["Save calibration setup", save_cal], ["Import calibration setup", import_cal]],
                      [ ["Calculate", recalc] ],
                      [ ["Help", not_yet] ]
                  ])

CanvasBox = Box(program_window, align = 'top', height=380, width='fill')
BottomBox = Box(program_window, align = 'top', height='fill', width='fill')

EmptyBox = Box(BottomBox, align = 'top', height=15, width=700)
RightPanel = Box(BottomBox, align = 'right', height='fill', width=350, layout='grid', border = False)
ButtonPanel = Box(BottomBox, align = 'right', height=225, width=625, layout='auto', border = False)
ButtonBox = Box(ButtonPanel, align = 'left', height=225, width=455, layout='grid', border = False)
LayoutBox = Box(ButtonPanel, align = 'right', height=225, width=170, layout='grid', border = False)
EmptyLayout = Box(LayoutBox, align = 'top', height = 75, width=170, layout='auto', grid=[0,0], border = False)
LayoutLayout = Box(LayoutBox, align = 'top', height = 150, width=170, layout='grid', grid=[0,1], border = False)

Doing_sequence1 = Text(RightPanel, text='1. Open your file', grid=[0,0], align='left')
Doing_sequence2 = Text(RightPanel, text='2. Give the cycle length in the pop-up window',grid=[0,1], align='left')
Doing_sequence3 = Text(RightPanel, text='3. Select your calibration wells', grid=[0,3], align='left')
Doing_sequence4 = Text(RightPanel, text='4. Fill the calibration amounts (pmol), click on:', grid=[0,4], align='left')
Pencil = Text(RightPanel, text='\u270e', size=20, grid=[1,4], align='left')
Doing_sequence5 = Text(RightPanel, text='5. Calculate', grid=[0,5], align='left')
Doing_sequence6 = Text(RightPanel, text='6. Deselect the outlier calibration points',grid=[0,6], align='left' )
Doing_sequence7 = Text(RightPanel, text='7. Export your results to Excel', grid=[0,7], align='left')

canvas = FigureCanvasTkAgg(program.fig, master=CanvasBox.tk)  # A tk.DrawingArea.
canvas.draw()
canvas.get_tk_widget().pack(side=tk.TOP, fill=tk.BOTH, expand=1)

'''
96-well button generation with the outer panels
'''
    
boxes = [[None for i in range(13)] for j in range(9)]
button = [[None for i in range(13)] for j in range(9)]
textboxes = [[None for i in range(13)] for j in range(9)]



for j in range(9):
    for i in range(13):
        boxes[j][i] = Box(ButtonBox, height = 25, width = 35, grid=[i, j])
        ButtonBox.when_mouse_leaves = restore_fit
        button[j][i] = PushButton(boxes[j][i], text='', height='fill', width='fill', padx= 0, pady=0)
        button[j][i].when_left_button_released = button_click_handler
        button[j][i].when_right_button_released = outlier_remover
        button[j][i].when_mouse_enters = show_fit
        button[j][i].when_mouse_leaves = restore_calib
        
        textboxes[j][i] = TextBox(boxes[j][i], text='', height='fill', width='fill')
        textboxes[j][i].when_key_released = text_change_handler
        textboxes[j][i].tk.config(justify='center')
        textboxes[j][i].hide()

button[0][0].text='\u270e'
button[0][0].text_size=20
for i in range(1, 13):
    button[0][i].text=str(i)
for j in range(1, 9):
    button[j][0].text=chr(ord('A')-1+j)



'''
button legends
'''
legend_texts = [[None for k in range(3)] for m in range(5)] #k column, m row
for m in range(4, 9):
    for k in range(3, 4):
    
        legend_texts[m - 4][k - 3] = Box(LayoutLayout, height = 25, width = 35, grid=[k, m])
        legend_texts[m - 4][k - 2] = Box(LayoutLayout, height = 25, width = 35, grid=[k + 1, m], border=True)
        legend_texts[m - 4][k - 1] = Box(LayoutLayout, height = 25, width = 100, grid=[k + 2, m])

button_color = Text(legend_texts[0][1], text='       ', bg='#FFA500')
button_legend_1 = Text(legend_texts[0][2], text='Calibration', align ='left')

button_color = Text(legend_texts[1][1], text='       ')
legend_texts[1][1].border = True
button_legend_2 = Text(legend_texts[1][2], text='Samples', align ='left')

button_color = Text(legend_texts[2][1], text='       ', bg='#C0C0C0')
button_legend_3 = Text(legend_texts[2][2], text='Outlier calib.', align ='left')

legend_texts[3][1].border = False
legend_texts[4][1].border = False
button_text = Text(legend_texts[3][1], text=' x ')
button_legend_4 = Text(legend_texts[3][2], text='Could not', align ='left')
button_legend_5 = Text(legend_texts[4][2], text='determine', align ='left')



gatc.display()




